QoreNumberNode Class Reference

Qore's arbitrary-precision number value type, dynamically-allocated only, reference counted. More...

`#include <QoreNumberNode.h>`

Inheritance diagram for QoreNumberNode:
[legend]
Collaboration diagram for QoreNumberNode:
[legend]

## Public Member Functions

DLLEXPORT | QoreNumberNode (const QoreValue n)
| creates a new number value from the node, if not possible then the new number will be assigned 0
DLLEXPORT | QoreNumberNode (double f)
| creates a new number value and assigns the initial value to it More...
DLLEXPORT | QoreNumberNode (int64 i)
| creates a new number value and assigns the initial value to it More...
DLLEXPORT | QoreNumberNode (const char *str)
| creates a new number value and assigns the initial value to it More...
DLLEXPORT | QoreNumberNode (const char *str, unsigned prec)
| creates a new number value and assigns the initial value to it More...
DLLEXPORT | QoreNumberNode ()
| creates a new numbering-point value and assigns it to 0
DLLEXPORT | QoreNumberNode (const QoreNumberNode &old)
| creates a copy of the object
DLLEXPORT QoreNumberNode * | doDivideBy (const QoreNumberNode &n, ExceptionSink *xsink) const
| divide this value by the argument return the result (can throw a division-by-zero exception)
DLLEXPORT QoreNumberNode * | doDivideBy (double d, ExceptionSink *xsink) const
| divide this value by the argument return the result (can throw a division-by-zero exception)
DLLEXPORT QoreNumberNode * | doDivideBy (int64 i, ExceptionSink *xsink) const
| divide this value by the argument return the result (can throw a division-by-zero exception)
DLLEXPORT QoreNumberNode * | doMinus (const QoreNumberNode &n) const
| subtract the argument from this value and return the result
DLLEXPORT QoreNumberNode * | doMultiply (const QoreNumberNode &n) const
| multiply the argument to this value and return the result
DLLEXPORT QoreNumberNode * | doPlus (const QoreNumberNode &n) const
| add the argument to this value and return the result
DLLEXPORT bool | equals (const QoreNumberNode &n) const
| returns true if the current object is equal to the argument
DLLEXPORT bool | equals (double n) const
| returns true if the current object is equal to the argument
DLLEXPORT bool | equals (int64 n) const
| returns true if the current object is equal to the argument
virtual DLLEXPORT int | getAsString (QoreString &str, int foff, class ExceptionSink *xsink) const
| concatenate the string representation of the number value to an existing QoreString More...
virtual DLLEXPORT QoreString * | getAsString (bool &del, int foff, class ExceptionSink *xsink) const
| returns a QoreString giving the string representation of the number value, sets del to true More...
virtual DLLEXPORT class DateTime * | getDateTimeRepresentation (bool &del) const
| returns the DateTime representation of this value and sets del to true More...
virtual DLLEXPORT void | getDateTimeRepresentation (DateTime &dt) const
| assigns the date representation of the value to the DateTime reference passed More...
DLLEXPORT unsigned | getPrec () const
| returns the precision of the number
virtual DLLEXPORT QoreString * | getStringRepresentation (bool &del) const
| returns the number value converted to a string and sets del to true More...
virtual DLLEXPORT void | getStringRepresentation (QoreString &str) const
| concatentates the number value to an existing QoreString reference, default implementation does nothing More...
virtual DLLEXPORT const char * | getTypeName () const
| returns the type name as a c string More...
DLLEXPORT bool | greaterThan (const QoreNumberNode &n) const
| returns true if the current object is greater than the argument
DLLEXPORT bool | greaterThan (double n) const
| returns true if the current object is greater than the argument
DLLEXPORT bool | greaterThan (int64 n) const
| returns true if the current object is greater than the argument
DLLEXPORT bool | greaterThanOrEqual (const QoreNumberNode &n) const
| returns true if the current object is greater than or equal to the argument
DLLEXPORT bool | greaterThanOrEqual (double n) const
| returns true if the current object is greater than or equal to the argument
DLLEXPORT bool | greaterThanOrEqual (int64 n) const
| returns true if the current object is greater than or equal to the argument
DLLEXPORT bool | inf () const
| returns true if the number is +/-inf
virtual DLLEXPORT bool | is_equal_hard (const AbstractQoreNode *v, ExceptionSink *xsink) const
| tests for equality without type conversions (hard compare) More...
virtual DLLEXPORT bool | is_equal_soft (const AbstractQoreNode *v, ExceptionSink *xsink) const
| tests for equality with possible type conversion (soft compare) More...
DLLEXPORT bool | lessThan (const QoreNumberNode &n) const
| returns true if the current object is less than the argument
DLLEXPORT bool | lessThan (double n) const
| returns true if the current object is less than the argument
DLLEXPORT bool | lessThan (int64 n) const
| returns true if the current object is less than the argument
DLLEXPORT bool | lessThanOrEqual (const QoreNumberNode &n) const
| returns true if the current object is less than or equal to the argument
DLLEXPORT bool | lessThanOrEqual (double n) const
| returns true if the current object is less than or equal to the argument
DLLEXPORT bool | lessThanOrEqual (int64 n) const
| returns true if the current object is less than or equal to the argument
DLLEXPORT bool | nan () const
| returns true if the number is NaN
DLLEXPORT QoreNumberNode * | negate () const
| returns the negative of the current object (this)
DLLEXPORT QoreNumberNode * | numberRefSelf () const
| returns a pointer to this with the reference count incremented
DLLEXPORT bool | ordinary () const
| returns true if the number is an ordinary number (neither NaN nor an infinity)
virtual DLLLOCAL int | parseInit (QoreValue &val, QoreParseContext &parse_context)
| returns the type information
virtual DLLEXPORT AbstractQoreNode * | realCopy () const
| returns a copy of the object; the caller owns the reference count More...
DLLEXPORT int | sign () const
| returns -1 if the number is negative, 0 if zero, or 1 if the number is positive
DLLEXPORT void | toString (QoreString &str, int fmt=QORE_NF_DEFAULT) const
| concatenates the string value corresponding to the number to the string given More...
DLLEXPORT bool | zero () const
| returns true if the number is zero
Public Member Functions inherited from SimpleValueQoreNode
DLLLOCAL | SimpleValueQoreNode (qore_type_t t, bool n_there_can_be_only_one=false)
| creates the object by assigning the type code and setting the "value" flag, unsetting the "needs_eval" flag, and setting "there_can_be_only_one"
Public Member Functions inherited from SimpleQoreNode
DLLLOCAL | SimpleQoreNode (qore_type_t t, bool n_value, bool n_needs_eval, bool n_there_can_be_only_one=false)
| constructor takes the type and value arguments
DLLLOCAL | SimpleQoreNode (const SimpleQoreNode &v)
| copy constructor
DLLEXPORT void | deref (ExceptionSink *xsink)
| decrements the reference count and deletes the object when references = 0 More...
SimpleQoreNode & | operator= (const SimpleQoreNode &)=delete
| this function is not implemented
Public Member Functions inherited from AbstractQoreNode
DLLEXPORT | AbstractQoreNode (qore_type_t t, bool n_value, bool n_needs_eval, bool n_there_can_be_only_one=false, bool n_custom_reference_handlers=false)
| constructor takes the type More...
DLLEXPORT | AbstractQoreNode (const AbstractQoreNode &v)
| copy constructor
virtual DLLEXPORT void | customDeref (ExceptionSink *xsink)
virtual DLLEXPORT void | customRef () const
| special processing when the object's reference count transitions from 0-1 More...
DLLEXPORT void | deref (ExceptionSink *xsink)
| decrements the reference count and calls derefImpl() if there_can_be_only_one is false, otherwise does nothing More...
virtual DLLEXPORT bool | derefImpl (ExceptionSink *xsink)
| decrements the reference count More...
DLLEXPORT QoreValue | eval (ExceptionSink *xsink) const
| evaluates the object and returns a value (or 0) More...
DLLEXPORT QoreValue | eval (bool &needs_deref, ExceptionSink *xsink) const
| optionally evaluates the argument More...
DLLEXPORT int64 | getAsBigInt () const
| returns the 64-bit integer value of the object More...
DLLEXPORT bool | getAsBool () const
| returns the boolean value of the object More...
DLLEXPORT double | getAsFloat () const
| returns the float value of the object More...
DLLEXPORT int | getAsInt () const
| returns the integer value of the object More...
DLLLOCAL qore_type_t | getType () const
| returns the data type More...
DLLLOCAL bool | is_value () const
| returns true if the node represents a value More...
DLLLOCAL bool | isReferenceCounted () const
| returns true if the object is reference-counted
DLLLOCAL bool | needs_eval () const
| returns true if the object needs evaluation to return a value, false if not More...
DLLLOCAL AbstractQoreNode & | operator= (const AbstractQoreNode &)
| this function is not implemented; it is here as a private function in order to prohibit it from being used
DLLEXPORT void | ref () const
| increments the reference count
DLLEXPORT AbstractQoreNode * | refSelf () const
| returns "this" with an incremented reference count More...
Public Member Functions inherited from QoreReferenceCounter
DLLEXPORT | QoreReferenceCounter ()
| creates the reference counter object
DLLEXPORT | QoreReferenceCounter (const QoreReferenceCounter &old)
| creates a new object with a reference count of 1 More...
DLLEXPORT | ~QoreReferenceCounter ()
| destroys the reference counter object
DLLEXPORT bool | is_unique () const
| returns true if the reference count is 1 More...
DLLEXPORT int | reference_count () const
| gets the reference count More...
DLLEXPORT bool | ROdereference () const
| atomically decrements the reference count More...
DLLEXPORT void | ROreference () const
| atomically increments the reference count

## Static Public Member Functions

static DLLLOCAL qore_type_t | getStaticTypeCode ()
| returns the type code (useful in templates)
static DLLLOCAL const char * | getStaticTypeName ()
| returns the type name (useful in templates) More...
static DLLEXPORT QoreNumberNode * | toNumber (const AbstractQoreNode *v)
| returns the representation of the value as a number if possible (otherwise returns 0), caller owns the reference returned
static DLLEXPORT QoreNumberNode * | toNumber (const QoreValue v)
| returns the representation of the value as a number if possible (otherwise returns 0), caller owns the reference returned

## Protected Member Functions

virtual DLLEXPORT | ~QoreNumberNode ()
| the destructor is protected because it should not be called directly More...
Protected Member Functions inherited from SimpleValueQoreNode
virtual DLLEXPORT QoreValue | evalImpl (bool &needs_deref, ExceptionSink *xsink) const
| should never be called for value types More...
Protected Member Functions inherited from AbstractQoreNode
virtual DLLEXPORT | ~AbstractQoreNode ()
| default destructor does nothing More...

## Protected Attributes

struct qore_number_private * | priv
| the private implementation of the type
Protected Attributes inherited from AbstractQoreNode
bool | custom_reference_handlers: 1
| set to one for objects that need custom reference handlers
bool | needs_eval_flag: 1
| if this is true then the type can be evaluated
bool | there_can_be_only_one: 1
| if this is set to true, then reference counting is turned off for objects of this class
qore_type_t | type: 11
| the type of the object More...
bool | value: 1
| this is true for values, if false then either the type needs evaluation to produce a value or is a parse expression

## Detailed Description

Qore's arbitrary-precision number value type, dynamically-allocated only, reference counted.

## Constructor & Destructor Documentation

## ~QoreNumberNode()

virtual DLLEXPORT QoreNumberNode::~QoreNumberNode | ( |  | ) |

protectedvirtual

the destructor is protected because it should not be called directly

See also
  SimpleValueQoreNode::deref()

## QoreNumberNode() [1/4]

DLLEXPORT QoreNumberNode::QoreNumberNode | ( | double | f | ) |

creates a new number value and assigns the initial value to it

Parameters

  f | the value for the object

## QoreNumberNode() [2/4]

DLLEXPORT QoreNumberNode::QoreNumberNode | ( | int64 | i | ) |

creates a new number value and assigns the initial value to it

Parameters

  i | the value for the object

## QoreNumberNode() [3/4]

DLLEXPORT QoreNumberNode::QoreNumberNode | ( | const char * | str | ) |

creates a new number value and assigns the initial value to it

Parameters

  str | the value for the object

## QoreNumberNode() [4/4]

DLLEXPORT QoreNumberNode::QoreNumberNode | ( | const char * | str,
|  | unsigned | prec
| ) |  |

creates a new number value and assigns the initial value to it

Parameters

  str | the value for the object
  prec | the initial precision for the number

## Member Function Documentation

## getAsString() [1/2]

virtual DLLEXPORT int QoreNumberNode::getAsString | ( | QoreString & | str,
|  | int | foff,
|  | class ExceptionSink * | xsink
| ) |  | const

virtual

concatenate the string representation of the number value to an existing QoreString

used for n and N printf formatting

Parameters

  str | the string representation of the type will be concatenated to this QoreString reference
  foff | for multi-line formatting offset, ignored by this implementation of the function
  xsink | ignored by this implementation of the function

Returns
  -1 for exception raised, 0 = OK

Implements AbstractQoreNode.

## getAsString() [2/2]

virtual DLLEXPORT QoreString* QoreNumberNode::getAsString | ( | bool & | del,
|  | int | foff,
|  | class ExceptionSink * | xsink
| ) |  | const

virtual

returns a QoreString giving the string representation of the number value, sets del to true

Used for n and N printf formatting. Do not call this function directly; use the QoreNodeAsStringHelper class (defined in QoreStringNode.h) instead

Parameters

  del | if this is true when the function returns, then the returned QoreString pointer should be deleted, if false, then it must not be
  foff | for multi-line formatting offset, ignored by this implementation of the function
  xsink | ignored by this implementation of the function

See also
  QoreNodeAsStringHelper

Implements AbstractQoreNode.

## getDateTimeRepresentation() [1/2]

virtual DLLEXPORT class DateTime* QoreNumberNode::getDateTimeRepresentation | ( | bool & | del | ) | const

virtual

returns the DateTime representation of this value and sets del to true

The DateTime representation is calculated by converting the number value to an integer interpreted as the number of seconds offset from January 1, 1970.

Note
  Use the DateTimeValueHelper class instead of using this function directly

Parameters

  del | output parameter: if del is true, then the returned DateTime pointer belongs to the caller (and must be deleted manually), if false, then it must not be

See also
  DateTimeValueHelper

Reimplemented from AbstractQoreNode.

## getDateTimeRepresentation() [2/2]

virtual DLLEXPORT void QoreNumberNode::getDateTimeRepresentation | ( | DateTime & | dt | ) | const

virtual

assigns the date representation of the value to the DateTime reference passed

The DateTime representation is calculated by converting the number value to an integer interpreted as the number of seconds offset from January 1, 1970.

Parameters

  dt | the DateTime reference to be assigned

Reimplemented from AbstractQoreNode.

## getStaticTypeName()

static DLLLOCAL const char* QoreNumberNode::getStaticTypeName | ( |  | ) |

inlinestatic

returns the type name (useful in templates)

Returns
  the type name as a c string

## getStringRepresentation() [1/2]

virtual DLLEXPORT QoreString* QoreNumberNode::getStringRepresentation | ( | bool & | del | ) | const

virtual

returns the number value converted to a string and sets del to true

NOTE: do not use this function directly, use QoreStringValueHelper instead

Parameters

  del | output parameter: del is set to true, meaning that the resulting QoreString pointer belongs to the caller (and must be deleted manually)

Returns
  a QoreString pointer, use the del output parameter to determine ownership of the pointer

See also
  QoreStringValueHelper

Reimplemented from AbstractQoreNode.

## getStringRepresentation() [2/2]

virtual DLLEXPORT void QoreNumberNode::getStringRepresentation | ( | QoreString & | str | ) | const

virtual

concatentates the number value to an existing QoreString reference, default implementation does nothing

Parameters

  str | a reference to a QoreString where the value of the type will be concatenated

Reimplemented from AbstractQoreNode.

## getTypeName()

virtual DLLEXPORT const char* QoreNumberNode::getTypeName | ( |  | ) | const

virtual

returns the type name as a c string

Returns
  the type name as a c string

Implements AbstractQoreNode.

## is_equal_hard()

virtual DLLEXPORT bool QoreNumberNode::is_equal_hard | ( | const AbstractQoreNode * | v,
|  | ExceptionSink * | xsink
| ) |  | const

virtual

tests for equality without type conversions (hard compare)

Parameters

  v | the value to compare
  xsink | ignored by this implementation of the function

Returns
  true if the objects are equal, false if not

Implements AbstractQoreNode.

## is_equal_soft()

virtual DLLEXPORT bool QoreNumberNode::is_equal_soft | ( | const AbstractQoreNode * | v,
|  | ExceptionSink * | xsink
| ) |  | const

virtual

tests for equality with possible type conversion (soft compare)

Parameters

  v | the value to compare
  xsink | ignored by this implementation of the function

Returns
  true if the objects are equal, false if not

Implements AbstractQoreNode.

## realCopy()

virtual DLLEXPORT AbstractQoreNode* QoreNumberNode::realCopy | ( |  | ) | const

virtual

returns a copy of the object; the caller owns the reference count

Returns
  a copy of the object; the caller owns the reference count

Implements AbstractQoreNode.

## toString()

DLLEXPORT void QoreNumberNode::toString | ( | QoreString & | str,
|  | int | fmt = `QORE_NF_DEFAULT`
| ) |  | const

concatenates the string value corresponding to the number to the string given

Parameters

  str | the string to append to
  fmt | a bitfield of number format flags

The documentation for this class was generated from the following file:

- include/qore/QoreNumberNode.h